"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _postcss = _interopRequireDefault(require("postcss"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let charset = 'charset';

var _default = _postcss.default.plugin('postcss-normalize-' + charset, (opts = {}) => {
  return css => {
    let charsetRule;
    let nonAsciiNode; // eslint-disable-next-line no-control-regex

    let nonAscii = /[^\x00-\x7F]/;
    css.walk(node => {
      if (node.type === 'atrule' && node.name === charset) {
        if (!charsetRule) {
          charsetRule = node;
        }

        node.remove();
      } else if (!nonAsciiNode && node.parent === css && nonAscii.test(node)) {
        nonAsciiNode = node;
      }
    });

    if (nonAsciiNode) {
      if (!charsetRule && opts.add !== false) {
        charsetRule = _postcss.default.atRule({
          name: charset,
          params: '"utf-8"'
        });
      }

      if (charsetRule) {
        charsetRule.source = nonAsciiNode.source;
        css.prepend(charsetRule);
      }
    }
  };
});

exports.default = _default;
module.exports = exports.default;